#!/usr/bin/env python
# -*- coding: UTF8 -*-

import pygtk
pygtk.require('2.0')

import gnome.ui
import gtk, gnomeapplet, gobject

import sys, os, popen2, pprint
import gnome_hotswap_applet_globals as pglobals


class HotswapApplet(gnomeapplet.Applet):
	
	def __init__(self,applet,iid):

		# do it a gobject. Look at Lorenzo Gil tutorial about sub-classing gobject in Python
		self.__gobject_init__()

		self.pp = pprint.PrettyPrinter(indent=2)
		
		self.tooltips_ = gtk.Tooltips()
		self.applet_ = applet
		
		self.image_ = gtk.Image()
		self.applet_.add(self.image_)
		self.applet_.connect("button-press-event", self.button_press)
	
		self.probe_bus()
		
		self.refresh()
	# end __init__

	def button_press(self, widget, event):
		propxml="""<popup name="button3">"""
		verbs = []
		if (self.devicePresent_ == 1): # Present
			propxml+="""<menuitem name="Item 1" verb="Remove" label="_Remove..." pixtype="filename" pixname=\""""+pglobals.image_dir+"""/hi16-action-remove.png"/>"""
			verbs = [ ("Remove", self.remove_device) ]
		else:
			propxml+="""<menuitem name="Item 1" verb="Insert" label="_Rescan..." pixtype="filename" pixname=\""""+pglobals.image_dir+"""/hi16-action-insert.png" enabled="false"/>"""
			verbs = [ ("Insert", self.insert_device) ]
		# end if
		
		propxml+="""<separator/>"""
		#propxml+="""<menuitem name="Item 2" verb="Props" label="_Preferences..." pixtype="stock" pixname="gtk-properties"/>"""
		#verbs.append( ("Props", self.properties ) )
		propxml+="""<menuitem name="Item 2" verb="About" label="_About..." pixtype="stock" pixname="gnome-stock-about"/>"""
		verbs.append( ("About", self.about_info ) )
		propxml+="""</popup>"""

		#self.pp.pprint(verbs)
		
		self.applet_.setup_menu(propxml,verbs,None)
	#end button_press

	def remove_device(self, widget, event):
		self.unregister_bus()
		self.probe_bus()
		self.refresh()
	# end def

	def insert_device(self, widget, event):
		self.rescan_bus()
		self.probe_bus()
		self.refresh()
	# end def
	
	def properties(self, widget, event):
		print "Properties"
	# end def

	def about_info(self, widget, event):
		email = 'Jean-Eric Cuendet <jec@rptec.ch>'
		logo_pixbuf = gtk.gdk.pixbuf_new_from_file(os.path.join(pglobals.image_dir,'hi48-app.png'))
		about = gnome.ui.About( "IDE Hotswap applet",pglobals.version,"GPL",\
                			"GNOME Applet to manage IDE Hotswap",[email],\
					[email],email,logo_pixbuf)
		about.show()
	# end def
	
	def refresh(self):
		#image = self.applet_.get_children()[0]
		if (self.devicePresent_ == 1):
			file = pglobals.image_dir+"/hi22-gnome-hotswap-device.png"
		else:
			file = pglobals.image_dir+"/hi22-gnome-hotswap-nodevice.png"
		# end if
		#print "Taking "+file
		self.image_.set_from_file(file)
		
		self.tooltips_.set_tip(self.applet_, self.deviceName_)
		
		self.applet_.show_all()

		return 1 # Call again
	# end refresh

	def run_cmd(self, cmd, localized):
		if (not localized):
			cmd="LANG=C "+cmd
		# end if
		(fr, fw) = popen2.popen2(cmd)
		fw.close()
		s = fr.readlines()
		if (len(s) > 0):
			return s[0].rstrip()
		return None

	def rescan_bus(self):
		self.run_cmd("hotswap rescan-ide", True)
	# end rescan_bus

	def probe_bus(self):
		s = self.run_cmd("hotswap probe-ide", False)
		if (s == "absent"):
			self.devicePresent_ = 0
		else:
			self.devicePresent_ = 1
		# end if
		s = self.run_cmd("hotswap probe-ide", True)
		self.deviceName_ = s
		return s
	# end probe_bus

	def unregister_bus(self):
		self.run_cmd("hotswap unregister-ide", True)
	# end unregister_bus
	
	def set_device_name(self):
		self.DeviceNameLabel.set_text(self.deviceName_)
	# end set_device_name
	
# end class

def HotswapApplet_factory(applet, iid):
	HotswapApplet(applet, iid)
	return gtk.TRUE


# Only if we tun it in cmdline with --run-in-window
if len(sys.argv) == 2 and sys.argv[1] == "run-in-window":
	print "Running in DEBUG mode"
	main_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	main_window.set_title("Python Applet")
	main_window.connect("destroy", gtk.mainquit)
	app = gnomeapplet.Applet()
	HotswapApplet_factory(app, None)
	app.reparent(main_window)
	main_window.show_all()
	gtk.main()
	sys.exit()

# Real applet code
gnomeapplet.bonobo_factory("OAFIID:GNOME_HotswapApplet_Factory",
                                     gnomeapplet.Applet.__gtype__,
                                     "Hotswap applet", "0", HotswapApplet_factory)
