/* safeexec.h

   Defines a simplified interface for executing an external program
   after dropping privileges.

   Copyright (C) 2008 Tim Stadelmann

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef SAFEEXEC_H
#define SAFEEXEC_H


/** FUNCTION DECLARATIONS **/

/* safeexec

   Execute the executable file identified by path with the privileges
   of the real user ID.  Command line arguments are provided in the
   argv array, which is termiated by a NULL entry.  The function waits
   for the executable file to terminate and returns its exit status.
   If dropping the privileges of the effective user ID or executing
   the file failed for any reason, EXIT_FAILURE is returned.  */

extern int safeexec (const char *path, char *const argv[]);


#endif /* SAFEEXEC_H */
